<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaPointInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaPointInsert extends AbstractStructArrayBase
{
    /**
     * The ViaPointInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaPointInsert[]
     */
    public $ViaPointInsert;
    /**
     * Constructor method for ArrayOfViaPointInsert
     * @uses ArrayOfViaPointInsert::setViaPointInsert()
     * @param \StructType\ViaPointInsert[] $viaPointInsert
     */
    public function __construct(array $viaPointInsert = array())
    {
        $this
            ->setViaPointInsert($viaPointInsert);
    }
    /**
     * Get ViaPointInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaPointInsert[]|null
     */
    public function getViaPointInsert()
    {
        return isset($this->ViaPointInsert) ? $this->ViaPointInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViaPointInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViaPointInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViaPointInsertForArrayConstraintsFromSetViaPointInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViaPointInsertViaPointInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaPointInsertViaPointInsertItem instanceof \StructType\ViaPointInsert) {
                $invalidValues[] = is_object($arrayOfViaPointInsertViaPointInsertItem) ? get_class($arrayOfViaPointInsertViaPointInsertItem) : sprintf('%s(%s)', gettype($arrayOfViaPointInsertViaPointInsertItem), var_export($arrayOfViaPointInsertViaPointInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViaPointInsert property can only contain items of type \StructType\ViaPointInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViaPointInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointInsert[] $viaPointInsert
     * @return \ArrayType\ArrayOfViaPointInsert
     */
    public function setViaPointInsert(array $viaPointInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($viaPointInsertArrayErrorMessage = self::validateViaPointInsertForArrayConstraintsFromSetViaPointInsert($viaPointInsert))) {
            throw new \InvalidArgumentException($viaPointInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($viaPointInsert) || (is_array($viaPointInsert) && empty($viaPointInsert))) {
            unset($this->ViaPointInsert);
        } else {
            $this->ViaPointInsert = $viaPointInsert;
        }
        return $this;
    }
    /**
     * Add item to ViaPointInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointInsert $item
     * @return \ArrayType\ArrayOfViaPointInsert
     */
    public function addToViaPointInsert(\StructType\ViaPointInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaPointInsert) {
            throw new \InvalidArgumentException(sprintf('The ViaPointInsert property can only contain items of type \StructType\ViaPointInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViaPointInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaPointInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaPointInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaPointInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaPointInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaPointInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaPointInsert
     */
    public function getAttributeName()
    {
        return 'ViaPointInsert';
    }
}
